<template>
  <div class="tags-view-container">
    <scroll-pane
      class="tags-view-wrapper"
      ref="scrollPane"
    >
      <router-link
        ref="tag"
        class="tags-view-item"
        :class="isActive(tag) ? 'active' : ''"
        v-for="tag in Array.from(visitedViews)"
        :to="tag.path"
        :key="tag.path"
      >
        <span class="tags-text"> {{ tag.title }} </span>
        <span
          class="el-icon-close"
          @click.prevent.stop="closeSelectedTag(tag)"
        ></span>
      </router-link>
    </scroll-pane>
    <!-- <ul
      class="contextmenu"
      v-show="visible"
      :style="{ left: left + 'px', top: top + 'px' }"
    >
      <li @click="closeSelectedTag(selectedTag)">关闭</li>
      <li @click="closeOthersTags">关闭其余所有标签</li>
      <li @click="closeAllTags">关闭所有标签</li>
    </ul> -->
  </div>
</template>

<script>
import ScrollPane from '../ScrollPane';
import { mapGetters, mapActions } from 'vuex';
import store from './store.js';

export default {
  name: 'tags-views',
  components: { ScrollPane },
  created() {
    store.install(this.$store);
  },
  data() {
    return {
      visible: false,
      top: 0,
      left: 0,
      selectedTag: {},
    };
  },
  computed: {
    ...mapGetters(['visitedViews']),
  },
  watch: {
    $route() {
      this.addViewTags();
      this.moveToCurrentTag();
    },
  },
  mounted() {
    this.addViewTags();
  },
  methods: {
    ...mapActions(['addVisitedViews', 'delVisitedViews']),
    generateRoute() {
      if (this.$route.name) {
        return this.$route;
      }
      return false;
    },
    isActive(route) {
      return route.path === this.$route.path || route.name === this.$route.name;
    },
    addViewTags() {
      const route = this.generateRoute();
      if (!route) {
        return false;
      }
      this.addVisitedViews(route);
    },
    moveToCurrentTag() {
      const tags = this.$refs.tag;
      this.$nextTick(() => {
        if (tags && tags.length) {
          for (const tag of tags) {
            if (tag.to === this.$route.path) {
              this.$refs.scrollPane.moveToTarget(tag.$el);
              break;
            }
          }
        }
      });
    },
    closeSelectedTag(view) {
      if (view.store) view.store.uninstall(this.$store);
      this.delVisitedViews(view).then(views => {
        if (this.isActive(view)) {
          const latestView = views.slice(-1)[0];
          if (latestView) {
            this.$router.push(latestView.path);
          } else {
            this.$router.push('/');
          }
        }
      });
    },
  },
};
</script>

<style rel="stylesheet/scss" lang="scss" scoped>
.tags-view-container {
  overflow: hidden;
  background-color: #fff;
  box-shadow: 0 2px 5px #999;
  .tags-view-wrapper {
    height: 30px;
    overflow: inherit;
    // border-bottom: 1px solid #d8dce5;
    // box-shadow: 0 1px 3px 0 rgba(0, 0, 0, 0.12), 0 0 3px 0 rgba(0, 0, 0, 0.04);
    .tags-view-item {
      display: inline-block;
      box-sizing: border-box;
      position: relative;
      min-width: 80px;
      height: 30px;
      line-height: 30px;
      color: #333;
      background: #fff;
      padding: 0 15px;
      font-size: 12px;
      text-align: center;
      transition: all 0.28s;
      &.active {
        color: #1459fc;
        border-bottom: 2px solid #1459fc;
        border-color: #1459fc;
        // &::before {
        //   content: "";
        //   background: #fff;
        //   display: inline-block;
        //   width: 8px;
        //   height: 8px;
        //   border-radius: 50%;
        //   position: relative;
        //   margin-right: 2px;
        // }
      }
    }
    .tags-text {
      display: inline-block;
    }
  }
  .contextmenu {
    margin: 0;
    background: #fff;
    z-index: 2;
    position: absolute;
    list-style-type: none;
    padding: 5px 0;
    border-radius: 4px;
    font-size: 12px;
    font-weight: 400;
    color: #333;
    box-shadow: 2px 2px 3px 0 rgba(0, 0, 0, 0.3);
    li {
      margin: 0;
      padding: 7px 16px;
      cursor: pointer;
      &:hover {
        background: #eee;
      }
    }
  }
}
</style>

<style rel="stylesheet/scss" lang="scss">
//reset element css of el-icon-close
.tags-view-wrapper {
  .tags-view-item {
    .el-icon-close {
      position: absolute;
      right: 3px;
      top: 9px;
      width: 12px;
      height: 12px;
      vertical-align: 2px;
      border-radius: 50%;
      text-align: center;
      transition: all 0.3s cubic-bezier(0.645, 0.045, 0.355, 1);
      transform-origin: 100% 50%;
      &:before {
        transform: scale(0.6);
        display: inline-block;
        vertical-align: 2px;
      }
      &:hover {
        background-color: #b4bccc;
        color: #fff;
      }
    }
  }
}
</style>
